#include <sys/mman.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>

typedef unsigned long __u32;
typedef unsigned char __u8;
typedef unsigned short __u16;

int main(int argc, char** argv)
{
  int fd;
  static const __u8 translate[64] = 
    {
      000, 001, 010, 020, 011, 002, 003, 012, 
      021, 030, 040, 031, 022, 013, 004, 005, 
      014, 023, 032, 041, 050, 060, 051, 042,
      033, 024, 015, 006, 007, 016, 025, 034, 
      043, 052, 061, 070, 071, 062, 053, 044,
      035, 026, 017, 027, 036, 045, 054, 063, 
      072, 073, 064, 055, 046, 037, 047, 056, 
      065, 074, 075, 066, 057, 067, 076, 077
    };
  __u32 * table = (__u32*) 0x10047650;
  __u32 * table2 = (__u32*) 0x10049a50;
  int lastvalue = -1;
  int lastskip = -1;
  int lastbits = 1;
  int i,j;

  fd = open("LVCodek2.dll.bin", O_RDONLY);
  mmap((void*)(0x10001000), 380416, 
       PROT_EXEC|PROT_READ|PROT_WRITE,
       MAP_FIXED | MAP_PRIVATE, fd, 0);

  printf("static __u8 shiftTables[18][64] = {\n");
  for (i = 0; i < 18; i++)
    {
      printf("  {");
      for ( j = 0; j < 64; j++)
	{
	  if (j == 32)
	    printf("\n   ");
	  printf("%d", table[i * 64 + translate[j]]);
	  if (j < 63)
	    printf(",");
	}
      printf(" },\n");
    }
  printf("};\n");
  printf("static __s16 scaleTable[64] = {");
  for ( j = 0; j < 64; j++)
    {
      if (!(j & 7))
	printf("\n   ");
      printf("%6d", table2[0 * 64 + translate[j]]);
      if (j < 63)
	printf(",");
    }
  printf("\n};\n");
  return 0;
}
